Package: prome
Title: Patient-Reported Outcome Data Analysis with Stan
Type: Package
Version: 4.0.2.5
Authors@R: person(given = "Bin",
	   family = "Wang", role = c("aut", "cre"),
	   email = "bwang831@gmail.com")
Description: Estimation for blinding bias in randomized controlled trials with
  a latent continuous outcome, a binary response depending on treatment and the
  latent outcome, and a noisy surrogate subject to possibly response-dependent
  measurement error. Implements EM estimators in R backed by compiled C routines
  for models with and without the restriction delta0 = 0, and Bayesian Stan
  wrappers for the same two models. Functions were added for latent outcome
  models with differential measurement error.
License: Unlimited
Encoding: UTF-8
Depends: R (>= 4.1.0), BI
Imports: stats, utils, rstan, bridgesampling
LinkingTo: Rcpp, RcppEigen, StanHeaders
Suggests: posterior
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-24 01:46:09 UTC; alkb
Author: Bin Wang [aut, cre]
Maintainer: Bin Wang <bwang831@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-26 19:50:02 UTC
Built: R 4.5.2; aarch64-apple-darwin20; 2026-04-27 00:00:19 UTC; unix
Archs: prome.so.dSYM

Package: prome
Title: Patient-Reported Outcome Data Analysis with Stan
Type: Package
Version: 4.0.2.5
Authors@R: person(given = "Bin",
	   family = "Wang", role = c("aut", "cre"),
	   email = "bwang831@gmail.com")
Description: Estimation for blinding bias in randomized controlled trials with
  a latent continuous outcome, a binary response depending on treatment and the
  latent outcome, and a noisy surrogate subject to possibly response-dependent
  measurement error. Implements EM estimators in R backed by compiled C routines
  for models with and without the restriction delta0 = 0, and Bayesian Stan
  wrappers for the same two models. Functions were added for latent outcome
  models with differential measurement error.
License: Unlimited
Encoding: UTF-8
Depends: R (>= 4.1.0), BI
Imports: stats, utils, rstan, bridgesampling
LinkingTo: Rcpp, RcppEigen, StanHeaders
Suggests: posterior
RoxygenNote: 7.3.3
NeedsCompilation: yes
Packaged: 2026-04-24 01:46:09 UTC; alkb
Author: Bin Wang [aut, cre]
Maintainer: Bin Wang <bwang831@gmail.com>
Repository: CRAN
Date/Publication: 2026-04-26 19:50:02 UTC

# EM fit with free `delta0` and `delta1`
#
# Fits the latent-outcome model
# \deqn{X|T \sim N(\mu_0 + \tau T, \sigma_X^2),}
# \deqn{G|X,T \sim \text{Bernoulli}(\text{logit}^{-1}(\alpha_0 + \alpha_T T + \alpha_X (X-\mu_0))),}
# \deqn{W|X,G=g \sim N(X + \delta_g, \sigma_{Wg}^2).}
#
# The E-step and observed-data log-likelihood are evaluated in compiled C code
# for speed.
#
# @param W Numeric surrogate outcome.
# @param T Binary treatment indicator.
# @param G Binary response indicator.
# @param max_iter Maximum EM iterations.
# @param tol Convergence tolerance.
# @param grid_size Number of E-step grid points.
# @param grid_sd Grid half-width in posterior SD units.
# @param verbose Print iteration trace.
# @param compute_se Compute approximate SEs from a numerical observed Hessian.
# @param hess_step Finite-difference step for Hessian approximation.
# @param init Optional named list of initial values.
#
# @return An object of class `rctme_fit`.
# @export
fit_rctme_em <- function(W, T, G,
                         max_iter = 200,
                         tol = 1e-6,
                         grid_size = 81,
                         grid_sd = 6,
                         verbose = FALSE,
                         compute_se = TRUE,
                         hess_step = 1e-4,
                         init = NULL) {
  .validate_inputs(W, T, G)
  W <- as.numeric(W)
  T <- as.integer(T)
  G <- as.integer(G)
  var_floor <- 1e-8

  if (is.null(init)) {
    mu0 <- mean(W[T == 0])
    tau <- mean(W[T == 1]) - mean(W[T == 0])
    sigmaX2 <- stats::var(W)
    if (!is.finite(sigmaX2) || sigmaX2 <= 0) sigmaX2 <- 1
    delta0 <- 0
    delta1 <- 0
    sigmaW0_2 <- 0.25 * sigmaX2
    sigmaW1_2 <- 0.25 * sigmaX2
    fit0 <- try(stats::glm(G ~ T + W, family = stats::binomial()), silent = TRUE)
    if (inherits(fit0, "try-error")) {
      alpha0 <- stats::qlogis(mean(G)); alphaT <- 0; alphaX <- 0
    } else {
      cf <- stats::coef(fit0)
      alpha0 <- ifelse(is.finite(cf[1]), cf[1], stats::qlogis(mean(G)))
      alphaT <- ifelse(is.finite(cf[2]), cf[2], 0)
      alphaX <- ifelse(is.finite(cf[3]), cf[3], 0)
    }
  } else {
    mu0 <- if (!is.null(init$mu0)) init$mu0 else init$beta0; tau <- init$tau; sigmaX2 <- init$sigmaX2
    alpha0 <- init$alpha0; alphaT <- init$alphaT; alphaX <- init$alphaX
    delta0 <- init$delta0; delta1 <- init$delta1
    sigmaW0_2 <- init$sigmaW0_2; sigmaW1_2 <- init$sigmaW1_2
  }

  loglik_trace <- numeric(max_iter)
  post_mean <- post_second <- NULL
  xgrid <- wpost <- NULL
  converged <- FALSE

  for (iter in seq_len(max_iter)) {
    old <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta0, delta1, sigmaW0_2, sigmaW1_2)
    sigmaX2 <- max(sigmaX2, var_floor)
    sigmaW0_2 <- max(sigmaW0_2, var_floor)
    sigmaW1_2 <- max(sigmaW1_2, var_floor)

    par <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta0, delta1, sigmaW0_2, sigmaW1_2)
    estep <- .c_estep(W, T, G, par, grid_size, grid_sd, delta0_fixed = FALSE)
    post_mean <- estep$post_mean
    post_second <- estep$post_second
    xgrid <- estep$xgrid
    wpost <- estep$wpost
    loglik_trace[iter] <- estep$loglik

    Z <- cbind(1, T)
    beta_hat <- solve(crossprod(Z), crossprod(Z, post_mean))
    mu0 <- unname(beta_hat[1]); tau <- unname(beta_hat[2])
    mu <- mu0 + tau * T
    sigmaX2 <- mean(post_second - 2 * mu * post_mean + mu^2)
    sigmaX2 <- max(sigmaX2, var_floor)

    idx0 <- which(G == 0L)
    idx1 <- which(G == 1L)
    if (length(idx0)) {
      delta0 <- mean(W[idx0] - post_mean[idx0])
      sigmaW0_2 <- mean((W[idx0] - delta0)^2 - 2 * (W[idx0] - delta0) * post_mean[idx0] + post_second[idx0])
      sigmaW0_2 <- max(sigmaW0_2, var_floor)
    }
    if (length(idx1)) {
      delta1 <- mean(W[idx1] - post_mean[idx1])
      sigmaW1_2 <- mean((W[idx1] - delta1)^2 - 2 * (W[idx1] - delta1) * post_mean[idx1] + post_second[idx1])
      sigmaW1_2 <- max(sigmaW1_2, var_floor)
    }

    opt <- stats::optim(c(alpha0, alphaT, alphaX),
      fn = function(a) -.c_q_alpha(xgrid, wpost, T, G, a, mu0),
      method = "BFGS", control = list(maxit = 200, reltol = 1e-10)
    )
    alpha0 <- opt$par[1]; alphaT <- opt$par[2]; alphaX <- opt$par[3]

    new <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta0, delta1, sigmaW0_2, sigmaW1_2)
    dpar <- max(abs(new - old))
    dll <- if (iter == 1) Inf else loglik_trace[iter] - loglik_trace[iter - 1]
    if (verbose) message(sprintf("iter=%d logLik=%.6f max|dpar|=%.3e dLL=%.3e", iter, loglik_trace[iter], dpar, dll))
    if (iter > 1 && abs(dll) < tol && dpar < sqrt(tol)) {
      converged <- TRUE
      loglik_trace <- loglik_trace[seq_len(iter)]
      break
    }
    if (iter == max_iter) loglik_trace <- loglik_trace[seq_len(iter)]
  }

  est <- c(mu0 = mu0, tau = tau, sigmaX2 = sigmaX2,
           alpha0 = alpha0, alphaT = alphaT, alphaX = alphaX,
           delta0 = delta0, delta1 = delta1,
           sigmaW0_2 = sigmaW0_2, sigmaW1_2 = sigmaW1_2)

  se <- NULL; vcov <- NULL
  if (compute_se) {
    theta_hat <- c(mu0, tau, log(sigmaX2), alpha0, alphaT, alphaX, delta0, delta1, log(sigmaW0_2), log(sigmaW1_2))
    obj_theta <- function(theta) {
      par_nat <- c(theta[1], theta[2], exp(theta[3]), theta[4], theta[5], theta[6], theta[7], theta[8], exp(theta[9]), exp(theta[10]))
      .c_loglik(W, T, G, par_nat, grid_size, grid_sd, delta0_fixed = FALSE)
    }
    H <- .numeric_hessian(obj_theta, theta_hat, step = hess_step)
    info <- -H
    Vtheta <- try(solve(info), silent = TRUE)
    if (!inherits(Vtheta, "try-error") && all(is.finite(Vtheta))) {
      J <- diag(c(1, 1, sigmaX2, 1, 1, 1, 1, 1, sigmaW0_2, sigmaW1_2))
      vcov <- J %*% Vtheta %*% t(J)
      colnames(vcov) <- rownames(vcov) <- names(est)
      se <- sqrt(pmax(diag(vcov), 0))
    }
  }
  .make_em_result(est, post_mean, post_second, loglik_trace, converged, length(loglik_trace), se = se, vcov = vcov, call = match.call())
}

# EM fit with `delta0` fixed at 0
#
# Same model as [fit_rctme_em()] but with the measurement-error mean shift in
# the `G = 0` group fixed at zero.
#
# @inheritParams fit_rctme_em
# @return An object of class `rctme_fit`.
# @export
fit_rctme_em_delta0_fixed <- function(W, T, G,
                                      max_iter = 200,
                                      tol = 1e-6,
                                      grid_size = 81,
                                      grid_sd = 6,
                                      verbose = FALSE,
                                      compute_se = TRUE,
                                      hess_step = 1e-4,
                                      init = NULL) {
  .validate_inputs(W, T, G)
  W <- as.numeric(W)
  T <- as.integer(T)
  G <- as.integer(G)
  var_floor <- 1e-8

  if (is.null(init)) {
    mu0 <- mean(W[T == 0])
    tau <- mean(W[T == 1]) - mean(W[T == 0])
    sigmaX2 <- stats::var(W)
    if (!is.finite(sigmaX2) || sigmaX2 <= 0) sigmaX2 <- 1
    delta1 <- 0
    sigmaW0_2 <- 0.25 * sigmaX2
    sigmaW1_2 <- 0.25 * sigmaX2
    fit0 <- try(stats::glm(G ~ T + W, family = stats::binomial()), silent = TRUE)
    if (inherits(fit0, "try-error")) {
      alpha0 <- stats::qlogis(mean(G)); alphaT <- 0; alphaX <- 0
    } else {
      cf <- stats::coef(fit0)
      alpha0 <- ifelse(is.finite(cf[1]), cf[1], stats::qlogis(mean(G)))
      alphaT <- ifelse(is.finite(cf[2]), cf[2], 0)
      alphaX <- ifelse(is.finite(cf[3]), cf[3], 0)
    }
  } else {
    mu0 <- if (!is.null(init$mu0)) init$mu0 else init$beta0; tau <- init$tau; sigmaX2 <- init$sigmaX2
    alpha0 <- init$alpha0; alphaT <- init$alphaT; alphaX <- init$alphaX
    delta1 <- init$delta1; sigmaW0_2 <- init$sigmaW0_2; sigmaW1_2 <- init$sigmaW1_2
  }

  loglik_trace <- numeric(max_iter)
  post_mean <- post_second <- NULL
  xgrid <- wpost <- NULL
  converged <- FALSE

  for (iter in seq_len(max_iter)) {
    old <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta1, sigmaW0_2, sigmaW1_2)
    sigmaX2 <- max(sigmaX2, var_floor)
    sigmaW0_2 <- max(sigmaW0_2, var_floor)
    sigmaW1_2 <- max(sigmaW1_2, var_floor)

    par <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta1, sigmaW0_2, sigmaW1_2)
    estep <- .c_estep(W, T, G, par, grid_size, grid_sd, delta0_fixed = TRUE)
    post_mean <- estep$post_mean
    post_second <- estep$post_second
    xgrid <- estep$xgrid
    wpost <- estep$wpost
    loglik_trace[iter] <- estep$loglik

    Z <- cbind(1, T)
    beta_hat <- solve(crossprod(Z), crossprod(Z, post_mean))
    mu0 <- unname(beta_hat[1]); tau <- unname(beta_hat[2])
    mu <- mu0 + tau * T
    sigmaX2 <- mean(post_second - 2 * mu * post_mean + mu^2)
    sigmaX2 <- max(sigmaX2, var_floor)

    idx0 <- which(G == 0L)
    idx1 <- which(G == 1L)
    if (length(idx0)) {
      sigmaW0_2 <- mean(W[idx0]^2 - 2 * W[idx0] * post_mean[idx0] + post_second[idx0])
      sigmaW0_2 <- max(sigmaW0_2, var_floor)
    }
    if (length(idx1)) {
      delta1 <- mean(W[idx1] - post_mean[idx1])
      sigmaW1_2 <- mean((W[idx1] - delta1)^2 - 2 * (W[idx1] - delta1) * post_mean[idx1] + post_second[idx1])
      sigmaW1_2 <- max(sigmaW1_2, var_floor)
    }

    opt <- stats::optim(c(alpha0, alphaT, alphaX),
      fn = function(a) -.c_q_alpha(xgrid, wpost, T, G, a, mu0),
      method = "BFGS", control = list(maxit = 200, reltol = 1e-10)
    )
    alpha0 <- opt$par[1]; alphaT <- opt$par[2]; alphaX <- opt$par[3]

    new <- c(mu0, tau, sigmaX2, alpha0, alphaT, alphaX, delta1, sigmaW0_2, sigmaW1_2)
    dpar <- max(abs(new - old))
    dll <- if (iter == 1) Inf else loglik_trace[iter] - loglik_trace[iter - 1]
    if (verbose) message(sprintf("iter=%d logLik=%.6f max|dpar|=%.3e dLL=%.3e", iter, loglik_trace[iter], dpar, dll))
    if (iter > 1 && abs(dll) < tol && dpar < sqrt(tol)) {
      converged <- TRUE
      loglik_trace <- loglik_trace[seq_len(iter)]
      break
    }
    if (iter == max_iter) loglik_trace <- loglik_trace[seq_len(iter)]
  }

  est <- c(mu0 = mu0, tau = tau, sigmaX2 = sigmaX2,
           alpha0 = alpha0, alphaT = alphaT, alphaX = alphaX,
           delta0 = 0, delta1 = delta1,
           sigmaW0_2 = sigmaW0_2, sigmaW1_2 = sigmaW1_2)

  se <- NULL; vcov <- NULL
  if (compute_se) {
    theta_hat <- c(mu0, tau, log(sigmaX2), alpha0, alphaT, alphaX, delta1, log(sigmaW0_2), log(sigmaW1_2))
    obj_theta <- function(theta) {
      par_nat <- c(theta[1], theta[2], exp(theta[3]), theta[4], theta[5], theta[6], theta[7], exp(theta[8]), exp(theta[9]))
      .c_loglik(W, T, G, par_nat, grid_size, grid_sd, delta0_fixed = TRUE)
    }
    H <- .numeric_hessian(obj_theta, theta_hat, step = hess_step)
    info <- -H
    Vtheta <- try(solve(info), silent = TRUE)
    if (!inherits(Vtheta, "try-error") && all(is.finite(Vtheta))) {
      J <- diag(c(1, 1, sigmaX2, 1, 1, 1, 1, sigmaW0_2, sigmaW1_2))
      vcov_free <- J %*% Vtheta %*% t(J)
      free_names <- c("mu0", "tau", "sigmaX2", "alpha0", "alphaT", "alphaX", "delta1", "sigmaW0_2", "sigmaW1_2")
      colnames(vcov_free) <- rownames(vcov_free) <- free_names
      vcov <- matrix(0, 10, 10, dimnames = list(names(est), names(est)))
      idx <- c(1, 2, 3, 4, 5, 6, 8, 9, 10)
      vcov[idx, idx] <- vcov_free
      se <- sqrt(pmax(diag(vcov), 0))
    }
  }
  .make_em_result(est, post_mean, post_second, loglik_trace, converged, length(loglik_trace), se = se, vcov = vcov, call = match.call())
}

.subRubinRule <- function(thetai,ui){
  m <- length(thetai)
  stopifnot(length(ui) == m)
  ui <- ui^2
  theta <- mean(thetai)
  u <- mean(ui)
  B <- var(thetai)
  T <- u + (1+1/m)*B
  SE <- sqrt(T)
  nu <- (m-1)*(1+u/(1+1/m)/B)^2
  ME <- abs(qt(0.975,df=nu))
  ll <- theta - ME * SE
  ul <- theta + ME * SE
  c(theta,SE,ll,ul)
}

.generate_matrix_unique <- function(k,kmax=10,nlevels=2) {
  xset <- c(0:(nlevels-1))
  m <- round(log(kmax)/log(nlevels))
  if (k <= m) {
    mat <- expand.grid(rep(list(xset), k))
    mat <- as.matrix(mat)
  } else {
    seen <- list()
    mat <- matrix(NA, nrow = 0, ncol = k)
    
    while (nrow(mat) < kmax) {
      candidate <- sample(xset, k, replace = TRUE)
      key <- paste(candidate, collapse = "")
      
      if (!key %in% seen) {
        seen[[length(seen) + 1]] <- key
        mat <- rbind(mat, candidate)
      }
    }
  }
  
  colnames(mat) <- paste0("V", seq_len(k))
  return(mat)
}


#' Unblinding bias correction
#'
#' @param W Numeric surrogate outcome.
#' @param T Binary treatment indicator.
#' @param G Binary response indicator.
#' @param method fitting/test method.
#' @param impute missing data or DNK response imputation.
#' 
#' @return An object of class `rctme_fit`.
#' @export
#'
#' @examples
#' \dontrun{
#' if (requireNamespace("rstan", quietly = TRUE)) {
#' sigma = 1.2
#' sig.theta = 1.0
#' beta0 = 0
#' beta1 = 1
#' beta2 = 2
#' ntreat = nsham = 100
#' Tind  = c(rep(1, ntreat), rep(0,nsham))  #treatment group indicator
#' u1v   = rep(u1,ntreat)
#' u2v   = rep(u2,nsham)
#' uv    = c(u1v,u2v)
#' tauv  = uv - rep(u2, ntreat+nsham)
#' r = rnorm(ntreat + nsham, mean = 0, sd = sigma)
#' x = uv + r #actual endpoint outcome
#' q = 1/(1 + exp(-(beta0 + beta1*Tind + beta2*(tauv+r))))
#' bernGen = function(qq){rbinom(1,1,qq)}
#' I = sapply(q,bernGen)
#' rsham = rnorm(ntreat + nsham, mean = 0, sd = sig.theta)
#' w = x + (theta + rsham)*I
#' lm0 = lm(w~Tind)
#' tau1 = lm0$coef[2]; tau1
#' u12 = tapply(w,Tind,FUN=mean,na.rm=TRUE)
#' lm1 = lm(w~Tind+I)
#' tau2 = lm1$coef[2]; tau2
#' mydata <- data.frame(y=w,group=Tind,guess=I)
#' out1 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
#'                       method='BI',impute=TRUE)
#' out1 # Blinding Index test
#' 
#' out2 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
#'                       method='classic',impute=TRUE)
#' out2 # classic estimate (t-test like)
#' 
#' out3 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
#'                       method='adjusted',impute=TRUE)
#' out3 # ANOVA or linear regression using G as a covariate
#' 
#' out4 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
#'                       method='EM',impute=TRUE)
#' out4 # MLE using EM-algorithm
#' 
#' out5 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
#'                       method='Bayes',impute=TRUE)
#' out5 # MLE using Bayes MCMC
#' }
#' }
#' 

blinding.test <- function(W,T,G,method='adjust',impute=TRUE){
  .validate_inputs(W,T,G)
  method <- match.arg(
    tolower(method), c("mle","cpe","adjusted","classic",
                      "bayes", "stan","em","bi","bridge","waic"))

  if(method=="classic"){
    out <- blindingCLASSIC(y=W,group=T)
  }else if(method == 'bi'){
    out <- blindingBI(group = T, guess = G,impute=impute)
  }else if(method == 'adjusted'){
    out <- blindingADJ(y=W,group=T,guess=G,impute=impute)
  }else if(method == 'cpe'){
    out <- blindingCPE(y=W,group=T,guess=G,impute=impute)
  }else if(method == 'bridge'){
    out <- TestStan(W=W,T=T,G=G,method='bridge')
  }else if(method == 'waic'){
    out <- TestStan(W=W,T=T,G=G,method='waic')
  }else if(method == 'mle' || method == 'em'){
    out <- blindingEM(y=W,group=T,guess=G,impute=impute)
  }else{
    out <- blindingSTAN(y=W,group=T,guess=G,impute=impute)
  }
  out
}




blindingSTAN <- function(y,group,guess,impute=TRUE){
  out <- NULL
  sele <- is.na(guess)
  g2 <- guess[!sele]
  if (all(g2 %in% c(0, 1, 2))) {
    nlvl <- length(unique(g2))
  }else{
    stop("G must have values 0/1/2.", call. = FALSE)
  }
  if(any(sele)){
    if(impute){
      guess[sele] <- 2
    }else{
      y <- y[!sele]
      group <- group[!sele]
      guess <- guess[!sele]
    }
  }
  ## impute if guess=0/1/2, 
  ## compute directly if guess=0/1
  sele <- guess == 2
  k <- sum(sele)
  
  if(k == 0){
    out <- .compSTAN(y=y,group=group,guess=guess)
  }else{
    kmat <- .generate_matrix_unique(k,kmax=10,nlevels=2)
    out2 <- apply(kmat,1,.imputeSTAN,y=y,group=group,guess=guess)
    res1 <- .subRubinRule(thetai=out2[1,], ui=out2[2,])
    res2 <- .subRubinRule(thetai=out2[3,], ui=out2[4,])
    res3 <- .subRubinRule(thetai=out2[5,], ui=out2[6,])
    res4 <- .subRubinRule(thetai=out2[7,], ui=out2[8,])
    
    tmp <- rbind(res1,res2,res3,res4)
    out1 <- as.data.frame(tmp)
    rownames(out1) <- c("tau","mu0","delta1","alphaX")
    names(out1) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                     "95% UCL (2-Sided)")
    out$estimate <- out1
  }
  out
}

.imputeSTAN <- function(x,y,group,guess){
  sele <- guess == 2
  guess[sele] <- x
  out <- .compSTAN(y=y,group=group,guess=guess)
  stat <- c(out$tau, out$se, 
            out$summ[1,1], out$summ[1,2],
            out$summ[12,1], out$summ[12,2],
            out$summ[11,1], out$summ[11,2]
  )
  return(stat)
}

.compSTAN <- function(y,group,guess){
    fit_rctme_stan_delta0_fixed(W=y,T=group,G=guess)  
}


blindingEM <- function(y,group,guess,impute=TRUE){
  out <- NULL
  sele <- is.na(guess)
  g2 <- guess[!sele]
  if (all(g2 %in% c(0, 1, 2))) {
    nlvl <- length(unique(g2))
  }else{
    stop("G must have values 0/1/2.", call. = FALSE)
  }
  if(any(sele)){
    if(impute){
      guess[sele] <- 2
    }else{
      y <- y[!sele]
      group <- group[!sele]
      guess <- guess[!sele]
    }
  }
  ## impute if guess=0/1/2, 
  ## compute directly if guess=0/1
  sele <- guess == 2
  k <- sum(sele)

  if(k == 0){
    out <- .compEM(y=y,group=group,guess=guess)
  }else{
    kmat <- .generate_matrix_unique(k,kmax=10,nlevels=2)
    out2 <- apply(kmat,1,.imputeSTAN,y=y,group=group,guess=guess)
    res1 <- .subRubinRule(thetai=out2[1,], ui=out2[2,])
    res2 <- .subRubinRule(thetai=out2[3,], ui=out2[4,])
    res3 <- .subRubinRule(thetai=out2[5,], ui=out2[6,])
    res4 <- .subRubinRule(thetai=out2[7,], ui=out2[8,])
    
    tmp <- rbind(res1,res2,res3,res4)
    out1 <- as.data.frame(tmp)
    rownames(out1) <- c("tau","mu0","delta1","alphaX")
    names(out1) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                     "95% UCL (2-Sided)")
    out$estimate <- out1
  }
  out
}

.imputeEM <- function(x,y,group,guess){
  sele <- guess == 2
  guess[sele] <- x
  out <- .compEM(y=y,group=group,guess=guess)
  stat <- c(out$tau, out$se, 
            out$summ[1,1], out$summ[1,2],
            out$summ[12,1], out$summ[12,2],
            out$summ[11,1], out$summ[11,2]
  )
  return(stat)
}

.compEM <- function(y,group,guess){
    fit_rctme_em_delta0_fixed(W=y,T=group,G=guess)  
}

blindingCLASSIC <- function(y,group){
  out <- NULL
  Group <- as.factor(group)
  lm0 <- lm(y ~ Group)
  res <- summary(lm0)$coef
  out$estimate <- res
  out$tau <- res[2,1]
  out
}

blindingBI <- function(group, guess, impute=TRUE){
  out <- NULL
  sele <- is.na(guess)
  g2 <- guess[!sele]
  if (all(g2 %in% c(0, 1, 2))) {
    nlvl <- length(unique(g2))
  }else{
    stop("G must have values 0/1/2.", call. = FALSE)
  }
  if(any(sele)){
    if(impute){
      arm <- group
      arm[arm==0] = "B:Control"
      arm[arm==1] = "A:Treatment"
      blind <- guess
      g2 <- guess
      g2[sele] <- 4
      sele <- g2 == 0
      if(any(sele)) blind[sele] <- "2:Control"
      sele <- g2 == 1
      if(any(sele)) blind[sele] <- "1:Treatment"
      sele <- g2 == 2
      if(any(sele)) blind[sele] <- "3:DNK"
      sele <- g2 == 4
      if(any(sele)) blind[sele] <- "4:NA"
      out$tbl <- table(blind, arm)

      k <- sum(sele)
      kmat <- .generate_matrix_unique(k,kmax=100,nlevels=nlvl)
      out2 <- apply(kmat,1,.imputeBI,group=group,guess=guess)
      res1 <- .subRubinRule(thetai=out2[1,], ui=out2[2,])
      ## JBL range [0,+1]
      res1[3] <- max(res1[3],0)
      res1[4] <- min(res1[4],1)
      
      res2c <- .subRubinRule(thetai=out2[3,], ui=out2[4,])
      res2t <- .subRubinRule(thetai=out2[5,], ui=out2[6,])
      ## BBL range [-1,+1]
      res2c[3] <- max(res2c[3],-1)
      res2c[4] <- min(res2c[4],1)
      res2t[3] <- max(res2t[3],-1)
      res2t[4] <- min(res2t[4],1)
      
      tmp <- rbind(NULL,res1)
      res0 <- as.data.frame(tmp)
      rownames(res0) <- "Overall"
      names(res0) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                       "95% UCL (2-Sided)")
      JBI <- res0
      
      tmp <- rbind(res2t, res2c)
      res0 <- as.data.frame(tmp)
      rownames(res0) <- c("Treatment", "Control")
      names(res0) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                       "95% UCL (2-Sided)")
      BBI <- res0
      tmp <- list(JamesBI = JBI, BangBI = BBI)
      out$BI <- tmp
      
    }else{
      group <- group[!sele]
      guess <- guess[!sele]
      out <- .compBI(group,guess)
    }
  }else{
    out <- .compBI(group,guess)
  }
  out
}

.imputeBI <- function(x,group,guess){
  sele <- is.na(guess)
  guess[sele] <- x
  BIres <- .compBI(group=group,guess=guess)
  res <- c(BIres$BI$JamesBI[1,1],BIres$BI$JamesBI[1,2],
           BIres$BI$BangBI[2,1],BIres$BI$BangBI[2,2],
           BIres$BI$BangBI[1,1],BIres$BI$BangBI[1,2])
  return(res)
}

.compBI <- function(group,guess){
  if (all(guess %in% c(0, 1))) {
    arm <- group
    arm[arm==0] = "B:Placebo"
    arm[arm==1] = "A:Treatment"
    blind = guess
    blind[blind!=1] <- "2:Placebo"
    blind[blind==1] <- "1:Treatment"
    xtbl <- table(blind, arm)
    xtbl2 <- rbind(xtbl, "3:DNK"=c(0,0))
    res <- BI::BI(xtbl2)
  }else{
    arm <- group
    arm[arm==0] = "B:Placebo"
    arm[arm==1] = "A:Treatment"
    blind = rep("3:DNK",length(guess))
    blind[guess==0] <- "2:Placebo"
    blind[guess==1] <- "1:Treatment"
    xtbl <- table(blind, arm)
    res <- BI::BI(xtbl)
  }
  list(tbl=xtbl,BI=res)
}

blindingADJ <- function(y,group,guess,impute=TRUE){
  out <- NULL
  sele <- is.na(guess)
  g2 <- guess[!sele]
  if (all(g2 %in% c(0, 1, 2))) {
    nlvl <- length(unique(g2))
  }else{
    stop("G must have values 0/1/2.", call. = FALSE)
  }
  if(any(sele)){
    if(impute){
      k <- sum(sele)
      kmat <- .generate_matrix_unique(k,kmax=100,nlevels=nlvl)
      out2 <- apply(kmat,1,.imputeADJ,y=y,group=group,guess=guess)
      res1 <- .subRubinRule(thetai=out2[1,], ui=out2[2,])
      res2 <- .subRubinRule(thetai=out2[3,], ui=out2[4,])

      tmp <- rbind(res1,res2)
      out <- as.data.frame(tmp)
      rownames(out) <- c("mu0","tau")
      names(out) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                       "95% UCL (2-Sided)")
    }else{
      y <- y[!sele]
      group <- group[!sele]
      guess <- guess[!sele]
      out <- .compADJ(y,group,guess)
    }
  }else{
    out <- .compADJ(y,group,guess)
  }
  out
}

.compADJ <- function(y,group,guess){
  out <- NULL
  Group <- as.factor(group)
  Guess <- as.factor(guess)
  lm0 <- lm(y ~ Group + Guess)
  res <- summary(lm0)$coef
  out$estimate <- res
  out$tau <- res[2,1]
  out
}

.imputeADJ <- function(x,y,group,guess){
  sele <- is.na(guess)
  guess[sele] <- x
  res <- .compADJ(y=y,group=group,guess=guess)$estimate
  stat <- c(res[1,1],res[1,2],res[2,1],res[2,2])
  return(stat)
}



blindingCPE <- function(y,group,guess,impute=TRUE){
  out <- NULL
  sele <- is.na(guess)
  g2 <- guess[!sele]
  if (all(g2 %in% c(0, 1, 2))) {
    nlvl <- length(unique(g2))
  }else{
    stop("G must have values 0/1/2.", call. = FALSE)
  }
  if(any(sele)){
    if(impute){
      guess[sele] <- 2
    }else{
      y <- y[!sele]
      group <- group[!sele]
      guess <- guess[!sele]
    }
  }
  ## impute if guess=0/1/2, 
  ## compute directly if guess=0/1
  sele <- guess == 2
  k <- sum(sele)
  mu.y <- mean(y,na.rm=TRUE)
  sd.y <- sd(y,na.rm=TRUE)
  y0 <- (y - mu.y)/sd.y
  
  if(k == 0){
    res <- .compCPE(y=y0,group=group,guess=guess)

    out <- structure(list(
        fit = res,
        mu <- mu.y,
        sd <- sd.y,
        summary = res$estimate * sd.y,
        tau = res$estimate[2,1] * sd.y,
        theta = res$theta * sd.y
    ), class = "rctcpe_fit")

  }else{
    kmat <- .generate_matrix_unique(k,kmax=100,nlevels=2)
    out2 <- apply(kmat,1,.imputeCPE,y=y0,group=group,guess=guess)
    res1 <- .subRubinRule(thetai=out2[1,], ui=out2[2,])
    res2 <- .subRubinRule(thetai=out2[3,], ui=out2[4,])

    tmp <- rbind(res1,res2)
    out1 <- as.data.frame(tmp)
    rownames(out1) <- c("mu0","tau")
    names(out1) <- c("Estimate", "Std. Error", "95% LCL (2-Sided)",
                    "95% UCL (2-Sided)")

    out <- structure(list(
        fit = NULL,
        mu <- mu.y,
        sd <- sd.y,
        summary = out1 * sd.y,
        tau = out1[2,1] * sd.y
    ), class = "rctcpe_fit")
  }
  out
}

.imputeCPE <- function(x,y,group,guess){
  sele <- guess == 2
  guess[sele] <- x
  res <- .compCPE(y=y,group=group,guess=guess)$estimate
  stat <- c(res[1,1],res[1,2],res[2,1],res[2,2])
  return(stat)
}

.compCPE <- function(y,group,guess){
  db <- data.frame(y=y,group=group,guess=guess)
  lmout1 <- lm(y ~ group, data = db)
  res1 <- lmout1$coef[[2]]
  lmout2 <- lm(y ~ group + guess, data = db)
  res2 <- lmout2$coef[[2]]
  res3 <- lmout2$coef[[3]]
  res0 <- tapply(db$y, db$group, mean, na.rm=TRUE)
  usham <- max(abs(res1),abs(res2),abs(res3),abs(res0))
  
  out <- NULL
  d <- seq(from=0.0,to=3.0,length=200) * usham # 5/10 seemed too large
  b1 <- sapply(d, FUN=.cpe3dev, db=db)
  ## refine the grid --------------------
  out1  <- .cleangrid(d, b1);
  xmin <- out1$xmin; xmax <- out1$xmax
  d <- seq(from=xmin, to=xmax,length=199)
  b1 <- sapply(d, FUN=.cpe3dev, db=db)
  ## remove NAs from the searching grid
  sele <- is.na(b1)
  if(any(sele)){
    d <- d[!sele]; b1 <- b1[!sele]
  }
  out$x <- d; out$y <- b1
  ## define the range for cpe searching -------------
  out2 <- .definegrid(d, b1)
  out$xcut1 <- out2$xcut1
  out$xcut2 <- out2$xcut2
  out$p1.skew <- out2$p1.skew
  out$p2.skew <- out2$p2.skew
  out$xlrt <- out2$xlrt
  out$ylrt <- out2$ylrt
  out$lrtmin <- out2$lrtmin
  out$lrtmax <- out2$lrtmax
  out$xmax <- out2$xmax
  out$xddd <- out2$xddd
  out$yddd <- out2$yddd
  
  out3 <- .findcp_fast(x=out2$x, y=out2$y)
  out$theta <- out3$cpe
  out$xrss <- out3$x; out$yrss <- out3$y
  
  y2 <- db$y - out3$cpe * db$guess
  group <- db$group
  lm0 <- lm(y2 ~ group)
  out$estimate <- summary(lm0)$coef
  out
}

.definegrid <- function(x,y){
  n <- length(x)
  imax <- which.max(y)
  ymax <- y[imax]
  xmax <- x[imax]
  
  n1 <- imax - 1
  n2 <- n - imax
  p.left <- n1/n
  p.skew <- (ymax - y[1])/(ymax - y[n])
  
  dy <- diff(y)
  dx <- x[-1]
  idxmin <- which.min(dy)[1]
  dxmin <- dx[idxmin]
  n2lim <- sum(x < dxmin)
  idxmax <- which.max(dy)[1]
  dxmax <- dx[idxmax]
  n1lim <- sum(x <= dxmax)
  d <- (dx[1] + dxmax) * 0.5
  ## p.skew <- n1lim/n2lim * (n-n2lim)/n2lim * d
  p1.skew <- (dxmax - x[1])/(x[n] - x[1])
  p2.skew <- x[1]/x[n]
  yddd <- diff(dy); xddd = dx[-1]
  m1 <- 1; m2 <- n
  
  if(imax == 1){
    m1 <- 1
    m2 <- min(n, n2lim, 30)
  }else if(imax == n){
    m2 <- n
    m1 <- n - 30
  }else{
    n2u <- min(n2, n2lim - n1, n1)
    d1 <- n1lim - 1 
    d2 <- n2lim - n1lim
    d <- min(d1, d2)
    ##ctrl1 <- p1.skew
    ##ctrl1[p1.skew < 0.1] <- 0.1
    ##ctrl1[p1.skew > 0.35] <- 0.35
    ##dlt1 <- ctrl1
    ##ctrl2 <- p2.skew
    ##ctrl2[p2.skew < 0.02] <- 0.02
    #ctrl2[p2.skew > 0.45] <- 0.45
    ##dlt2 <- ctrl2
    if(p2.skew <= 0){
      m1 <- max(n1lim - (0.55 - 0.5*p1.skew) * d1, 1)
      m2 <- min(n1lim + (0.35 + 0.7*p1.skew) * d2, n2lim)
    }else{
      m1 <- max(n1lim - (0.85 + 0.70*p2.skew - 0.45*p1.skew) * d1, 1)
      m2 <- min(n1lim + (0.35 + 0.05*p2.skew - 0.35*p1.skew) * d2, n2lim)
    }
  }
  m1 <- max(1, round(m1)); m2 <- min(n,max(m1+20, round(m2)))
  
  list(x = x[m1:m2], y = y[m1:m2], 
       xlrt=dx, ylrt=dy, 
       xddd=xddd, yddd=yddd,
       lrtmin=dxmin, lrtmax=dxmax,
       p1.skew = p1.skew, 
       p2.skew = p2.skew, 
       xcut1 = x[m1], xcut2 = x[m2],# actual grid upper boundary
       xmax=xmax) # x of max(y)
}

.cpe3dev <- function(d,db){
  db$y <- db$y - d * db$guess
  sele <- db$guess == 1
  db$guess[sele] <- 1 
  db$guess[!sele] <- 0 
  g1 <- suppressWarnings(glm(guess ~ y, family = binomial(), data=db))
  if(any(max(abs(coef(g1)))>100))
    out = NA
  else
    out = g1$deviance[[1]]
  out
}

.cleangrid <- function(x,y){
  n <- length(x)
  stopifnot(length(y) == n)
  imax <- which.max(y)
  if(imax == 1){
    xmin <- x[1]
    rdy <- 0
    sele.na <- is.na(y)
    if(any(sele.na)){
      ina2 <- which(sele.na)[1]
      xmax <- x[ina2-1]
    }else{
      xmax <- x[n]
    }
  }else if(imax == n){
    xmax <- x[n]
    sele.na <- is.na(y)
    if(any(sele.na)){
      ina1 <- rev(which(sele.na))[1]
      xmin <- x[ina1+1]
    }else{
      xmin <- x[1]
    }
  }else{
    n1 <- imax - 1
    x1 <- x[1:n1]
    y1 <- y[1:n1]
    n2 <- n - imax
    x2 <- x[(imax + 1):n]
    y2 <- y[(imax + 1):n]
    ## left part --------------------------
    sele.na <- is.na(y1)
    if(any(sele.na)){
      ina1 <- rev(which(sele.na))[1]
      xmin <- x1[ina1 + 1]
    }else{
      xmin <- x1[1]
    }
    ## right part -------------------------
    sele.na <- is.na(y2)
    if(any(sele.na)){
      ina2 <- which(sele.na)[1]
      xmax <- x2[ina2 - 1]
    }else{
      xmax <- rev(x2)[1]
    }
  }
  list(xmin=xmin,xmax=xmax)
}


.findcp_fast <- function(x, y) {
  n <- length(y)
  stopifnot(length(x) == n)
  
  # starting point cannot be < 4
  k <- max(round(n * 0.1), 4L)
  if (n < 2*k + 2) stop("n is too small for this k.")
  
  x1 <- x
  x2 <- x1 * x1
  x3 <- x2 * x1
  x4 <- x2 * x2
  
  cy   <- c(0, cumsum(y))
  cx1  <- c(0, cumsum(x1))
  cx2  <- c(0, cumsum(x2))
  cx3  <- c(0, cumsum(x3))
  cx4  <- c(0, cumsum(x4))
  
  cxy1 <- c(0, cumsum(x1 * y))
  cxy2 <- c(0, cumsum(x2 * y))
  cyy  <- c(0, cumsum(y * y))
  
  seg_rss <- function(a, b) {
    s <- function(cs) cs[b + 1L] - cs[a]
    nseg <- b - a + 1L
    
    Sy   <- s(cy)
    Sx1  <- s(cx1)
    Sx2  <- s(cx2)
    Sx3  <- s(cx3)
    Sx4  <- s(cx4)
    Sxy1 <- s(cxy1)
    Sxy2 <- s(cxy2)
    Syy  <- s(cyy)
    
    XtX <- matrix(
      c(nseg, Sx1, Sx2,
        Sx1,  Sx2, Sx3,
        Sx2,  Sx3, Sx4),
      nrow = 3, byrow = TRUE
    )
    
    Xty <- c(Sy, Sxy1, Sxy2)
    
    R <- tryCatch(chol(XtX), error = function(e) NULL)
    if (is.null(R)) {
      b <- solve(XtX, Xty)
    } else {
      b <- backsolve(R, forwardsolve(t(R), Xty))
    }
    
    rss <- as.numeric(Syy - crossprod(b, Xty))
    if(is.na(rss)) rss <- 0
    if (rss < 0 && rss > -1e-10) rss <- 0
    rss
  }
  
  i_seq <- k:(n - k - 1L)
  m <- length(i_seq)
  rss_total <- numeric(m)
  
  for (j in seq_len(m)) {
    i <- i_seq[j]
    rss_total[j] <- seg_rss(1L, i) + seg_rss(i + 1L, n)
  }
  
  i_best <- i_seq[which.min(rss_total)]
  list(cpe=x[i_best], y=rss_total, x=x[i_seq])
}

# Internal input validation
# @keywords internal
.validate_inputs <- function(W, T, G) {
  if (any(is.na(T))){
    stop("Missing data not allowed in T")
  }
  if (any(is.na(W))){
    stop("Missing data not allowed in W")
  }

  if (length(W) != length(T) || length(W) != length(G)) {
    stop("W, T, and G must have the same length.", call. = FALSE)
  }
  if (any(!is.finite(W))) {
    stop("W must be finite.", call. = FALSE)
  }
  if (!all(T %in% c(0, 1))) {
    stop("T must be binary with values 0/1.", call. = FALSE)
  }
  invisible(TRUE)
}

.log1pexp <- function(z) ifelse(z > 35, z, log1p(exp(z)))

.numeric_hessian <- function(fn, x, step = 1e-4) {
  p <- length(x)
  H <- matrix(0, p, p)
  fx <- fn(x)
  for (j in seq_len(p)) {
    ej <- rep(0, p); ej[j] <- step
    f1 <- fn(x + ej)
    f2 <- fn(x - ej)
    H[j, j] <- (f1 - 2 * fx + f2) / step^2
  }
  if (p >= 2) {
    for (j in 1:(p - 1)) {
      for (k in (j + 1):p) {
        ej <- rep(0, p); ej[j] <- step
        ek <- rep(0, p); ek[k] <- step
        fpp <- fn(x + ej + ek)
        fpm <- fn(x + ej - ek)
        fmp <- fn(x - ej + ek)
        fmm <- fn(x - ej - ek)
        H[j, k] <- (fpp - fpm - fmp + fmm) / (4 * step^2)
        H[k, j] <- H[j, k]
      }
    }
  }
  H
}

.c_estep <- function(W, T, G, par, grid_size, grid_sd, delta0_fixed = FALSE) {
  if (delta0_fixed) {
      .Call("c_e_step_loglik_fixed", W, as.integer(T), as.integer(G),
            as.numeric(par), as.integer(grid_size), as.numeric(grid_sd))
  } else {
      .Call("c_e_step_loglik_free", W, as.integer(T), as.integer(G),
            as.numeric(par), as.integer(grid_size), as.numeric(grid_sd))
  }
}

.c_loglik <- function(W, T, G, par, grid_size, grid_sd, delta0_fixed = FALSE) {
  if (delta0_fixed) {
      .Call("c_loglik_fixed", W, as.integer(T), as.integer(G), as.numeric(par),
            as.integer(grid_size), as.numeric(grid_sd))[[1]]
  } else {
      .Call("c_loglik_free", W, as.integer(T), as.integer(G), as.numeric(par),
            as.integer(grid_size), as.numeric(grid_sd))[[1]]
  }
}

.c_q_alpha <- function(xgrid, wpost, T, G, alpha, mu0) {
    .Call("c_q_alpha", xgrid, wpost, as.integer(T), as.integer(G),
          as.numeric(alpha), as.numeric(mu0))[[1]]
}

.make_em_result <- function(estimates, post_mean, post_second, loglik_trace, converged, iterations, se = NULL, vcov = NULL, call = NULL) {
  structure(list(
    estimates = estimates,
    posterior_mean_X = post_mean,
    posterior_second_X = post_second,
    logLik = tail(loglik_trace, 1),
    logLik_trace = loglik_trace,
    converged = converged,
    iterations = iterations,
    se.est = se,
    vcov = vcov,
    tau = estimates[2],
    se = se[2],
    call = call
  ), class = "rctme_fit")
}

.make_stan_result1 <- function(fit, call = NULL) {
    pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2",
              "sigmaW0_2", "sigmaW1_2",
              "alpha0", "alphaT", "alphaX", "delta1")
    summ <- as.data.frame(rstan::summary(fit, pars = pars)$summary)

    draws <- as.data.frame(rstan::extract(fit, pars = "tau"))
    taux <- draws$tau
    tau.hat <- mean(taux, trim=0.1)
    
    draws <- as.data.frame(rstan::extract(fit, pars = "alphaX"))
    ax <- draws$alphaX
    ax.mean <- mean(ax)
    ax.ci <- quantile(ax, c(0.025, 0.5, 0.975))
    ROPE.05 <- mean(abs(ax) < 0.05) # example ROPE
    ROPE.15 <- mean(abs(ax) < 0.15) # example ROPE
    ROPE.25 <- mean(abs(ax) < 0.25) # example ROPE
    ROPE.50 <- mean(abs(ax) < 0.50) # example ROPE
    ax.ci1 <- mean(ax > 0)
    ax.out <- list(mean=ax.mean, median=ax.ci[[2]],
                   ci = c(ax.ci[[1]],ax.ci[[3]]),
                   ROPE.05 = ROPE.05,
                   ROPE.15 = ROPE.15,
                   ROPE.25 = ROPE.25,
                   ROPE.50 = ROPE.50,
                   p.gt.zero = ax.ci1)

    structure(list(
        fit = fit,
        summary = summ,
        tau = tau.hat,
        se = summ[2,2],
        contamination = ax.out,
        call = call
    ), class = "rctstan_fit")
}

.make_stan_result2 <- function(fit, call = NULL) {
    pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2",
              "sigmaW0_2", "sigmaW1_2", "alpha0", "alphaT", "alphaX",
              "delta0", "delta1")
    summ <- as.data.frame(rstan::summary(fit, pars = pars)$summary)
    ##list(fit = fit, summary = summ, stan_file = stan_file)

    draws <- as.data.frame(rstan::extract(fit, pars = "alphaX"))
    ax <- draws$alphaX
    ax.mean <- mean(ax)
    ax.ci <- quantile(ax, c(0.025, 0.5, 0.975))
    ROPE.05 <- mean(abs(ax) < 0.05) # example ROPE
    ROPE.15 <- mean(abs(ax) < 0.15) # example ROPE
    ROPE.25 <- mean(abs(ax) < 0.25) # example ROPE
    ROPE.50 <- mean(abs(ax) < 0.50) # example ROPE
    ax.ci1 <- mean(ax > 0)
    ax.out <- list(mean=ax.mean, median=ax.ci[[2]],
                   ci = c(ax.ci[[1]],ax.ci[[3]]),
                   ROPE.05 = ROPE.05,
                   ROPE.15 = ROPE.15,
                   ROPE.25 = ROPE.25,
                   ROPE.50 = ROPE.50,
                   p.gt.zero = ax.ci1)
    
    structure(list(
        fit = fit,
        summary = summ,
        tau = summ[2,1],
        se = summ[2,2],
        contamination = ax.out,
        call = call
    ), class = "rctstan_fit")
}

# Simulate a small RCT measurement-error example dataset
#
# Generates a toy dataset for examples and testing under the latent outcome
# model implemented in this package.
#
# @param n Sample size.
# @param mu0 Mean of latent outcome in controls.
# @param tau Treatment effect on latent outcome.
# @param sigmaX SD of latent outcome noise.
# @param alpha0,alphaT,alphaX Logistic-response coefficients.
# @param delta0,delta1 Mean measurement error shifts by response group.
# @param sigmaW0,sigmaW1 Measurement-error SDs by response group.
# @param seed Optional RNG seed.
#
# @return A data frame with columns \code{W}, \code{T}, \code{G}, and latent \code{X}.
# @export
simulate_rctme_data <- function(n = 200,
                                mu0 = 0.5,
                                tau = 1,
                                sigmaX = 1,
                                alpha0 = -0.5,
                                alphaT = 0.4,
                                alphaX = 1,
                                delta0 = 0,
                                delta1 = -0.4,
                                sigmaW0 = 0.8,
                                sigmaW1 = 1,
                                seed = NULL) {
  if (!is.null(seed)) set.seed(seed)
  T <- stats::rbinom(n, 1, 0.5)
  X <- stats::rnorm(n, mu0 + tau * T, sigmaX)
  p <- stats::plogis(alpha0 + alphaT * T + alphaX * (X - mu0))
  G <- stats::rbinom(n, 1, p)
  U <- ifelse(G == 0,
              stats::rnorm(n, delta0, sigmaW0),
              stats::rnorm(n, delta1, sigmaW1))
  W <- X + U
  data.frame(W = W, T = T, G = G, X = X)
}


#' @export
print.rctme_fit <- function(x, ...) {
  cat("MLE with EM\n")
  cat("Converged:", x$converged, "\n")
  cat("Iterations:", x$iterations, "\n")
  cat("Log-likelihood:", format(x$logLik, digits = 6), "\n\n")
  print(round(x$estimates, 4))
  if (!is.null(x$se.est)) {
    cat("\nApproximate SEs:\n")
    print(round(x$se.est, 4))
  }
  invisible(x)
}

#' @export
print.rctstan_fit <- function(x, ...) {
  cat("Bayesian with stan\n")
  print(round(x$summary, 4))
  if (!is.null(x$contamination)) {
      cat("\nContamination:\n\t95% CI=(", round(x$contamination$ci[1],4),
          ", ", round(x$contamination$ci[2],4), ")",
          "\n\tP(alphaX>0)=", round(x$contamination$p.gt.zero,4),
          "\n\tP(|alphaX|<0.05)=", round(x$contamination$ROPE.05,4),
          "\n\tP(|alphaX|<0.15)=", round(x$contamination$ROPE.15,4),
          "\n\tP(|alphaX|<0.25)=", round(x$contamination$ROPE.25,4),
          "\n\tP(|alphaX|<0.50)=", round(x$contamination$ROPE.50,4))
  }
  if (!is.null(x$tau)) {
    cat("\n\nApproximate MLE of tau: ", round(x$tau, 4))
  }
  if (!is.null(x$se)) {
    cat("\nApproximate SE of tau: ", round(x$se, 4),"\n\n")
  }
  invisible(x)
}

#' @export
print.rctcpe_fit <- function(x, ...) {
  cat("Change-point estimate\n")
  print(round(x$summary, 4))
  if (!is.null(x$tau)) {
    cat("\nApproximate MLE of tau: ", round(x$tau, 4),"\n\n")
  }
  invisible(x)
}

## Locate a bundled Stan file
prome_stan_file <- function(model = c(
  "delta0_fixed",
  "delta0_fixed_alphaX_zero",
  "delta0_fixed_alphaT_zero",
  "delta0_fixed_alphaTX_zero"
)) {
  model <- match.arg(model)
  file <- switch(model,
    delta0_fixed = system.file("stan", "delta0_fixed.stan", package = "prome"),
    delta0_fixed_alphaX_zero = system.file("stan", "delta0_fixed_alphaX_zero.stan",
                                           package = "prome"),
    delta0_fixed_alphaT_zero = system.file("stan", "delta0_fixed_alphaT_zero.stan",
                                           package = "prome"),
    delta0_fixed_alphaTX_zero = system.file("stan", "delta0_fixed_alphaTX_zero.stan",
                                            package = "prome")
  )
  if (!nzchar(file)) stop("Stan file not found.", call. = FALSE)
  file
}

.prome_stan_fit <- function(W, T, G, stan_model_key, pars)
 {
  .validate_inputs(W, T, G)
  .check_rstan()
  data_list <- list(N = length(W), T = as.integer(T), 
                    G = as.integer(G), W = as.numeric(W))
  stan_file <- prome_stan_file(stan_model_key)
  mod <- .get_rstan_model(stan_file)
  
  chains = 4
  cores = chains
  iter_warmup = 1000
  iter_sampling = 1000
  control = list(adapt_delta = 0.95, max_treedepth = 12)
  refresh = 0
  
  fit <- rstan::sampling(
    object = mod,
    data = data_list,
    chains = chains,
    cores = cores,
    iter = iter_warmup + iter_sampling,
    warmup = iter_warmup,
    refresh = refresh,
    control = control
  )
  summ <- as.data.frame(rstan::summary(fit, pars = pars)$summary)
  structure(list(
    fit = fit,
    summary = summ,
    stan_file = stan_file,
    model_key = stan_model_key
  ), class = "stan_test")
}

## Bayesian Stan fit with `delta0` fixed at 0
fit_delta0_fixed <- function(W, T, G) {
  pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2", 
            "sigmaW0_2", "sigmaW1_2", "alpha0", "alphaT", "alphaX", "delta1")
  .prome_stan_fit(W, T, G, "delta0_fixed", pars)
}

## Bayesian Stan fit with `alphaX = 0` and `delta0` fixed at 0
fit_delta0_fixed_alphaX_zero <- function(W, T, G) {
  pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2", 
            "sigmaW0_2", "sigmaW1_2", "alpha0", "alphaT", "delta1")
  .prome_stan_fit(W, T, G, "delta0_fixed_alphaX_zero", pars)
}

## Bayesian Stan fit with `alphaT = 0` and `delta0` fixed at 0
fit_delta0_fixed_alphaT_zero <- function(W, T, G) {
  pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2", 
            "sigmaW0_2", "sigmaW1_2", "alpha0", "alphaX", "delta1")
  .prome_stan_fit(W, T, G, "delta0_fixed_alphaT_zero", pars)
}

## Bayesian Stan fit with `alphaT = 0`, `alphaX = 0`, and `delta0` fixed at 0
fit_delta0_fixed_alphaTX_zero <- function(W, T, G) {
  pars <- c("mu0", "tau", "sigmaX", "sigmaW0", "sigmaW1", "sigmaX2", 
            "sigmaW0_2", "sigmaW1_2", "alpha0", "delta1")
  .prome_stan_fit(W, T, G, "delta0_fixed_alphaTX_zero", pars)
}

.extract_log_lik_matrix <- function(stanfit) {
  arr <- rstan::extract(stanfit, pars = "log_lik", 
                        permuted = FALSE, inc_warmup = FALSE)
  if (length(dim(arr)) == 3L) {
    mat <- matrix(arr, nrow = dim(arr)[1] * dim(arr)[2], ncol = dim(arr)[3])
  } else {
    mat <- arr
  }
  mat
}

.waic_from_loglik <- function(log_lik_mat) {
    lppd <- sum(log(colMeans(exp(log_lik_mat))))
    tmp <- apply(log_lik_mat, 2, var)
    p_waic <- sum(tmp)
    elpd_waic <- lppd - p_waic
    waic <- -2 * elpd_waic
    list(lppd = lppd, p_waic = p_waic, elpd_waic = elpd_waic, waic = waic)
}

## Compare four fixed-`delta0` Stan bias models and compute model probabilities
##
## Fits four nested response models for the `delta0 = 0` setting: null
## (`alphaT = 0`, `alphaX = 0`), design-only (`alphaT` free, `alphaX = 0`),
## outcome-only (`alphaT = 0`, `alphaX` free), and full (`alphaT` and
## `alphaX` free). Model probabilities are computed either by bridge sampling
## when the `bridgesampling` package is available, or by normalized WAIC weights
## as an approximation.
TestStan <- function(W, T, G, method = c("auto", "bridge", "waic")) {
  .validate_inputs(W, T, G)
  .check_rstan()
  method <- match.arg(method)
  model_priors <- rep(0.25, 4)
  model_priors <- as.numeric(model_priors) / sum(model_priors)
  names(model_priors) <- c("null", "design_only", "outcome_only", "full")

  fit_args <- list(W = W, T = T, G = G)

  fits <- list(
    null = do.call(fit_delta0_fixed_alphaTX_zero, fit_args),
    design_only = do.call(fit_delta0_fixed_alphaX_zero, fit_args),
    outcome_only = do.call(fit_delta0_fixed_alphaT_zero, fit_args),
    full = do.call(fit_delta0_fixed, fit_args)
  )

  use_bridge <- FALSE
  if (method == "bridge") {
    if (!requireNamespace("bridgesampling", quietly = TRUE)) {
      stop("bridgesampling is required for method = 'bridge'.", call. = FALSE)
    }
    use_bridge <- TRUE
  } else if (method == "auto" && requireNamespace("bridgesampling", quietly = TRUE)) {
    use_bridge <- TRUE
  }

  details <- list()
  if (use_bridge) {
    bridges <- lapply(fits, function(x) bridgesampling::bridge_sampler(x$fit, silent = TRUE))
    logml <- vapply(bridges, function(b) b$logml, numeric(1))
    log_post_unnorm <- logml + log(model_priors[names(logml)])
    log_post_norm <- log_post_unnorm - max(log_post_unnorm)
    probs <- exp(log_post_norm)
    probs <- probs / sum(probs)
    details$log_marginal_lik <- logml
    details$bridge_objects <- bridges
    method_used <- "bridge"
  } else {
    waic_list <- lapply(fits, function(x) .waic_from_loglik(.extract_log_lik_matrix(x$fit)))
    elpd <- vapply(waic_list, function(w) w$elpd_waic, numeric(1))
    log_post_unnorm <- elpd + log(model_priors[names(elpd)])
    log_post_norm <- log_post_unnorm - max(log_post_unnorm)
    probs <- exp(log_post_norm)
    probs <- probs / sum(probs)
    details$waic <- waic_list
    details$elpd_waic <- elpd
    method_used <- "waic"
  }

  summary_full <- fits$full$summary
  out <- list(
    method = method_used,
    model_priors = model_priors,
    model_probabilities = probs,
    full_summary = summary_full,
    details = details,
    fits = fits
  )
  class(out) <- "stanTest"
  out
}

#' @export
print.stanTest <- function(x, ...) {
  cat("Method:", x$method, "\n")
  probs <- round(x$model_probabilities, 4)
  print(probs)
  if (!is.null(x$full_summary) && all(c("mean", "2.5%", "97.5%") %in% colnames(x$full_summary))) {
    keep <- intersect(c("alphaT", "alphaX"), rownames(x$full_summary))
    if (length(keep)) {
      cat("Full-model posterior summary for bias coefficients:\n")
      print(x$full_summary[keep, c("mean", "sd", "2.5%", "50%", "97.5%"), drop = FALSE])
    }
  }
  invisible(x)
}

# Locate a bundled Stan file
#
# @param model One of `"delta0_fixed"` or `"delta_free"`.
#
# @return Path to the `.stan` file shipped with the package.
# @export
rctme_stan_file <- function(model = c("delta0_fixed", "delta_free")) {
  model <- match.arg(model)
  file <- switch(model,
    delta0_fixed = system.file("stan", "rctme_delta0_fixed.stan", package = "prome"),
    delta_free = system.file("stan", "rctme_delta_free.stan", package = "prome")
  )
  if (!nzchar(file)) stop("Stan file not found.", call. = FALSE)
  file
}

.stan_model_cache <- new.env(parent = emptyenv())

.check_rstan <- function() {
  if (!requireNamespace("rstan", quietly = TRUE)) {
    stop("rstan is required for Stan fitting. Install it first.", call. = FALSE)
  }
}

.get_rstan_model <- function(stan_file) {
  key <- normalizePath(stan_file, winslash = "/", mustWork = TRUE)
  if (!exists(key, envir = .stan_model_cache, inherits = FALSE)) {
    .stan_model_cache[[key]] <- rstan::stan_model(file = stan_file, auto_write = TRUE)
  }
  get(key, envir = .stan_model_cache, inherits = FALSE)
}

# Bayesian Stan fit with `delta0` fixed at 0
#
# Fits the restricted Bayesian latent-outcome model using `rstan` and the
# Stan program bundled with the package.
#
# @inheritParams fit_rctme_em
# @param chains Number of chains.
# @param cores Number of CPU cores for parallel sampling. Defaults to `chains`.
# @param iter_warmup Warmup iterations.
# @param iter_sampling Sampling iterations.
# @param control Optional named list of `rstan` control arguments such as
#   `list(adapt_delta = 0.95, max_treedepth = 12)`.
# @param refresh Stan refresh interval.
#
# @return A list with components `fit`, `summary`, and `stan_file`.
# @export
fit_rctme_stan_delta0_fixed <-
    function(W, T, G,
             chains = 4,
             cores = chains,
             iter_warmup = 1000,
             iter_sampling = 1000,
             control = list(adapt_delta = 0.95, max_treedepth = 12),
             refresh = 0) {
  .validate_inputs(W, T, G)
  .check_rstan()
  data_list <- list(N = length(W), T = as.integer(T),
                    G = as.integer(G), W = as.numeric(W))
  stan_file <- rctme_stan_file("delta0_fixed")
  mod <- .get_rstan_model(stan_file)
  fit <- rstan::sampling(
    object = mod,
    data = data_list,
    chains = chains,
    cores = cores,
    iter = iter_warmup + iter_sampling,
    warmup = iter_warmup,
    refresh = refresh,
    control = control
    )
  .make_stan_result1(fit, call = match.call())
}

# Bayesian Stan fit with free `delta0` and `delta1`
#
# Fits the unrestricted Bayesian latent-outcome model using `rstan` and the
# Stan program bundled with the package.
#
# @inheritParams fit_rctme_stan_delta0_fixed
# @return A list with components `fit`, `summary`, and `stan_file`.
# @export
#
fit_rctme_stan <- function(W, T, G,
                           chains = 4,
                           cores = chains,
                           iter_warmup = 1000,
                           iter_sampling = 1000,
                           control = list(adapt_delta = 0.95, max_treedepth = 12),
                           refresh = 0) {
  .validate_inputs(W, T, G)
  .check_rstan()
  data_list <- list(N = length(W), T = as.integer(T), G = as.integer(G), W = as.numeric(W))
  stan_file <- rctme_stan_file("delta_free")
  mod <- .get_rstan_model(stan_file)
  fit <- rstan::sampling(
    object = mod,
    data = data_list,
    chains = chains,
    cores = cores,
    iter = iter_warmup + iter_sampling,
    warmup = iter_warmup,
    refresh = refresh,
    control = control
  )
  .make_stan_result2(fit, call = match.call())
}

#' prome: Latent-outcome models for RCTs with differential measurement error
#'
#' Tools for fitting latent continuous-outcome models in randomized trials with
#' a binary response process and a surrogate measurement subject to
#' response-dependent error. The package provides EM estimators implemented with
#' compiled C code for fast E-steps and observed-data log-likelihood
#' evaluation, plus Bayesian Stan wrappers for corresponding models.
#'
#' @keywords internal
"_PACKAGE"

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rfunctions.R
\name{blinding.test}
\alias{blinding.test}
\alias{test.stan}
\title{Unblinding bias correction}
\usage{
blinding.test(W, T, G, method = "adjust", impute = TRUE)
}
\arguments{
\item{W}{Numeric surrogate outcome.}

\item{T}{Binary treatment indicator.}

\item{G}{Binary response indicator.}

\item{method}{fitting/test method.}

\item{impute}{missing data or DNK response imputation.}
}
\value{
An object of class `rctme_fit`.
}
\description{
Unblinding bias correction
}
\examples{
\dontrun{
if (requireNamespace("rstan", quietly = TRUE)) {
sigma = 1.2
sig.theta = 1.0
beta0 = 0
beta1 = 1
beta2 = 2
ntreat = nsham = 100
Tind  = c(rep(1, ntreat), rep(0,nsham))  #treatment group indicator
u1v   = rep(u1,ntreat)
u2v   = rep(u2,nsham)
uv    = c(u1v,u2v)
tauv  = uv - rep(u2, ntreat+nsham)
r = rnorm(ntreat + nsham, mean = 0, sd = sigma)
x = uv + r #actual endpoint outcome
q = 1/(1 + exp(-(beta0 + beta1*Tind + beta2*(tauv+r))))
bernGen = function(qq){rbinom(1,1,qq)}
I = sapply(q,bernGen)
rsham = rnorm(ntreat + nsham, mean = 0, sd = sig.theta)
w = x + (theta + rsham)*I
lm0 = lm(w~Tind)
tau1 = lm0$coef[2]; tau1
u12 = tapply(w,Tind,FUN=mean,na.rm=TRUE)
lm1 = lm(w~Tind+I)
tau2 = lm1$coef[2]; tau2
mydata <- data.frame(y=w,group=Tind,guess=I)
out1 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
                      method='BI',impute=TRUE)
out1 # Blinding Index test

out2 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
                      method='classic',impute=TRUE)
out2 # classic estimate (t-test like)

out3 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
                      method='adjusted',impute=TRUE)
out3 # ANOVA or linear regression using G as a covariate

out4 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
                      method='EM',impute=TRUE)
out4 # MLE using EM-algorithm

out5 <- blinding.test(W = mydata$y, T = mydata$group, G = mydata$guess,
                      method='Bayes',impute=TRUE)
out5 # MLE using Bayes MCMC
}
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prome-package.R
\docType{package}
\name{prome-package}
\alias{prome}
\alias{prome-package}
\title{prome: Latent-outcome models for RCTs with differential measurement error}
\description{
Tools for fitting latent continuous-outcome models in randomized trials with
a binary response process and a surrogate measurement subject to
response-dependent error. The package provides EM estimators implemented with
compiled C code for fast E-steps and observed-data log-likelihood
evaluation, plus Bayesian Stan wrappers for corresponding models.
}
\author{
\strong{Maintainer}: Bin Wang \email{bwang831@gmail.com}

}
\keyword{internal}
